Assignee: J. Wienke % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 0.3
Description

Atcually, we need to agree what information is mandatory metdata. Examples include:

    -  Sender and receiver URIs (once we defined the URI scheme)
    -  Timing
    -  TTL

I'd like to represent this information explicitly in the IDL and a metadata domain object.

Associated revisions
Revision 00ffc447 - 05/27/2011 06:25 PM - J. Wienke

add a dedicated meta-data object

refs #176

Revision 2ff7dd1f - 05/28/2011 09:19 PM - J. Moringen
Added MetData protocol buffer descriptor in rsbprotocol/MetaData.proto
refs #176
This change should be backwards-compatible.
    -  CMakeLists.txt: added file rsbprotocol/MetaData.proto
    -  rsbprotocol/MetaData.proto: new file MetaData protocol buffer

  descriptor; this implements the notification side of
https://code.cor-lab.de/projects/rsb/wiki/Events#Meta-Data

    -  rsbprotocol/Notification.proto: import MetaData.proto; added
  meta_data field of type MetaData

Revision 7f3e6b66 - 05/28/2011 09:49 PM - J. Moringen
Find protocol buffer descriptors using wildcard in build.xml
refs #176
    -  build.xml: changed protocol target to use apply with wildcard

  filesets instead of individual arg elements within exec

Revision 32be4265 - 05/28/2011 11:22 PM - J. Moringen
Made receiver side timestamps optional in rsbprotocol/MetaData.proto
refs #176
    -  rsbprotocol/MetaData.proto: made receive_time and deliver_time

  optional; there will be no need to transmit these over the network
  in most scenarios
Revision 21cc2729 - 05/31/2011 02:40 AM - J. Moringen
Fixed MetaData unit test in test/rsb/MetaDataTest.cpp
refs #176
    -  test/rsb/MetaDataTest.cpp: in test case testComparison do not expect

  two fresh MetaData objects to be identical since each of them
  generates a random sender id

Revision 1289b11d - 05/31/2011 02:52 AM - J. Moringen
Store sender ID compactly in src/rsb/transport/spread/OutConnector.cpp
refs #176
    -  src/rsb/transport/spread/OutConnector.cpp: store sender UUID as an

  array of 16 bytes instead of as its string representation

Revision b4d9e008 - 05/31/2011 03:25 AM - J. Moringen
Extended explanatory comment in rsbprotocol/MetaData.proto
refs #176
    -  rsbprotocol/MetaData.proto: mention that the sender's UUID should be

  stored in the sender_id field as an array of 16 bytes (as opposed to
  the string representation of the UUID)

Revision 4e2d1f6a - 05/31/2011 09:37 AM - J. Wienke

Ensure that connectors provide the required meta data

refs #176

Revision f78100ad - 05/31/2011 10:50 AM - J. Wienke

update protocol and meta data representation in C++ according to ticket

fixes #337 #339
refs #176

Revision a4e400b1 - 05/31/2011 10:50 AM - J. Wienke

update protocol and meta data representation in C++ according to ticket

fixes #337 #339
refs #176

Revision 450f5716 - 06/01/2011 08:50 AM - J. Moringen
Added Participant base class in rsb/__init__.py
refs #176 (since we need a sender id)
    -  rsb/__init__.py: added class Participant; Informer and Listener are

  now derived from Participant
Revision ebe0fed5 - 06/01/2011 09:25 AM - J. Moringen
Added MetaData class in rsb/__init__.py
refs #176
    -  rsb/__init__.py: added MetaData class; added MetaData class to Event

  class

Revision 1274d85f - 06/01/2011 09:43 AM - J. Moringen
Converted to new notification protocol buffer descriptors
refs #176
    -  rsb/__init__.py: store participant id as sender id in

  Informer.publishEvent
    -  rsb/util.py: added utility functions timeToUnixMicroseconds and

  unixMicrosecondsToTime
    -  rsb/rsbspread/__init__.py: use Protocol protocol buffer instead of

  Notification protocol buffer; adapted things accordingly
    -  test/rsbspreadtest.py: added sender ids to created event objects

Revision 780f5dc9 - 06/05/2011 09:00 AM - J. Moringen
Fixed compilation of src/rsb/MetaData.java
refs #176
    -  src/rsb/MetaData.java: added member variables userTimes and

  userInfos; fixed missing method bodies and return values; added
  toString method

Revision 1c1380d4 - 06/05/2011 10:48 AM - J. Moringen
Improved meta-data client interface in rsb/__init__.py
refs #176
    -  rsb/__init__.py: accept user-times and user-infos as keyword

  parameters in Event constructor; accept user-times and user-infos as
  keyword parameters in Informer.publishData method

Revision 38e7f4b4 - 06/05/2011 10:23 PM - J. Wienke

Finalize MetaData class for Java

refs #176

Revision 873e3d05 - 06/06/2011 10:40 AM - J. Wienke

introduce a Participant baseclass for informer and listener to have an Id for each participant

refs #176

Revision eb93c819 - 06/06/2011 02:14 PM - J. Wienke

Handle MetaData for events
refs #176

Revision abfea2cb - 06/06/2011 05:20 PM - J. Wienke

fixed and tested metadata support

fixes #176

Revision 5c8f9694 - 06/06/2011 05:46 PM - J. Wienke

fix sending and receiving of user times across spread

refs #176

Revision a1bb6f13 - 06/06/2011 06:37 PM - J. Moringen
Use System.currentTimeMillis instead of System.nanoTime
fixes #176
    -  src/rsb/MetaData.java: Use System.currentTimeMillis instead of

  System.nanoTime which does not yield absolute time measurements
    -  test/rsb/MetaDataTest.java: likewise
    -  test/rsb/eventprocessing/EventProcessorTest.java: likewise
    -  test/rsb/transport/spread/SpreadPortTest.java: likewise

History
#1 - 02/28/2011 12:13 PM - S. Wrede
- Category set to Protocol

#2 - 02/28/2011 03:13 PM - J. Wienke

I agree with the explicit representation. The variable metadata collection may still be useful.

#3 - 05/26/2011 03:15 PM - J. Wienke
- Project changed from RSB XCF Adapter to Robotics Service Bus
- Parent task deleted (#173)

#4 - 05/26/2011 03:16 PM - J. Wienke
- Target version set to 0.3

#5 - 05/27/2011 03:21 PM - J. Wienke
- Status changed from New to In Progress
- Assignee set to J. Wienke

I will integrate it for Python, Java and C++

#6 - 06/05/2011 12:49 PM - J. Moringen
- % Done changed from 0 to 70
#7 - 06/06/2011 05:30 PM - J. Wienke
- Status changed from In Progress to Resolved
- % Done changed from 70 to 100

Applied in changeset r1398.
